<?php
if( !defined('DATALIFEENGINE') ) {
    header( "HTTP/1.1 403 Forbidden" );
    header ( 'Location: ../../' );
    die( "Hacking attempt!" );
}

class PayAnyWay {

    private $config_this = [];
    private $config = [];


    // такой конструктор должен быть у всех платежных модулей
    public function __construct($config_this, $config)
    {
        $this->config_this = $config_this;
        $this->config = $config;
    }


    /**
     * @param $id - id записи в таблице kylshop_buy
     * @param $total - сумма заказа
     * @return string
     */
    public function init($id, $total, $secret_key, $data, $goods)
    {
        $data = json_decode($data, true);
        $mnt_id = $this->config_this->mnt_id;
        $mnt_secret = $this->config_this->mnt_secret;
        $mnt_amount = number_format($total, 2, '.', '');
        $mnt_transaction_id = $id;
        $mnt_currency_code = 'RUB';
        $mnt_test_mode = $this->config_this->mnt_testmode;
        $email = '';
        if(!empty($data["email"])) $email = $data["email"];
        if(!empty($data["Email"])) $email = $data["Email"];
        if(!empty($data["E-mail"])) $email = $data["E-mail"];
        $email_text = '';
        if (!empty($email))
            $email_text = ' для '.$email;
        $mnt_description = 'Заказ '.$id.$email_text;
        $mnt_signature = md5($mnt_id.$mnt_transaction_id.$mnt_amount.$mnt_currency_code.$mnt_test_mode.$mnt_secret);
        return '<form action="https://www.payanyway.ru/assistant.htm" method="POST">
            <input type="text" hidden name="MNT_ID" value="'.$mnt_id.'">
            <input type="text" hidden name="MNT_AMOUNT" value="'.$mnt_amount.'">
            <input type="text" hidden name="MNT_TRANSACTION_ID" value="'.$mnt_transaction_id.'">
            <input type="text" hidden name="MNT_CURRENCY_CODE" value="'.$mnt_currency_code.'">
            <input type="text" hidden name="MNT_TEST_MODE" value="'.$mnt_test_mode.'">
            <input type="text" hidden name="MNT_DESCRIPTION" value="'.$mnt_description.'">
            <input type="text" hidden name="MNT_SIGNATURE" value="'.$mnt_signature.'">
            <input type="submit" class="payment_btn" value="Перейти к оплате">
        </form>';
    }

    /**
     * @name метод, который проверяет прошел ли платеж или нет
     * возвращает id заказа если платеж прошел и null если не прошел
     * @return string
     */
    public function success()
    {
        if(isset($_GET["MNT_ID"]) && isset($_GET["MNT_TRANSACTION_ID"]) && isset($_GET["MNT_OPERATION_ID"]) &&
           isset($_GET["MNT_AMOUNT"]) && isset($_GET["MNT_CURRENCY_CODE"]) && isset($_GET["MNT_TEST_MODE"]) &&
           isset($_GET["MNT_SIGNATURE"]))
        {
        	$mnt_subscriber_id = '';
            if (isset($_GET['MNT_SUBSCRIBER_ID']))
            	$mnt_subscriber_id = $_GET['MNT_SUBSCRIBER_ID'];
            $calculated_signature = md5($_GET['MNT_ID'].$_GET['MNT_TRANSACTION_ID'].$_GET['MNT_OPERATION_ID'].
                $_GET['MNT_AMOUNT'].$_GET['MNT_CURRENCY_CODE'].$mnt_subscriber_id.$_GET['MNT_TEST_MODE'].
                $this->config_this->mnt_secret);
            if ($calculated_signature == $_GET['MNT_SIGNATURE'])
                return $_GET["MNT_TRANSACTION_ID"];
        }
        echo "FAIL";
        die();
    }
}